<?php

class Mageme_AjaxValidation_Model_Observer
    extends Mage_Core_Model_Abstract
{
    public function validate(Varien_Object $observer){
        /** @var VladimirPopov_WebForms_Model_Webforms $webform */
        $webform = $observer->getWebform();
        $validate = $observer->getValidate();
        $errors = $validate->getErrors();
        $postData = $webform->getPostData();
        $fields_to_fieldsets = $webform->getFieldsToFieldsets();

        // Iterate through all fields and find the validated one
        foreach($fields_to_fieldsets as $fieldset){
            foreach($fieldset['fields'] as $field){

                // Check field CSS class
                if(strstr($field->getCssClass(), Mageme_AjaxValidation_Helper_Data::CSS_CLASS)){

                    // Validate value with the helper
                    $status = Mage::helper('ajaxvalidation')->validate($postData[$field->getId()]);
                    if(!$status){

                        // Add error message
                        $errors[]=Mage::helper('ajaxvalidation')->getErrorText();
                    }
                }
            }
        }
        $validate->setErrors($errors);
    }
}